﻿var pw;

document.onreadystatechange = function() {
  if(document.readyState=="complete") {
  	// Gadget-Window merken um einfacher darauf zugreifen zu können
    pw = System.Gadget.document.parentWindow;
    // Page für Settings zuweisen
    System.Gadget.settingsUI = "Settings.htm";
    // Handler für Ein-/Ausklappen des Flyouts zuweisen
    System.Gadget.Flyout.onHide = Flyout_onHide;
    System.Gadget.Flyout.onShow = Flyout_onShow;
    if(System.Gadget.Settings.read("Zahlenformat") == ""){
      System.Gadget.Settings.write("Zahlenformat", "deutsch");
    }
  }
}

function Flyout_onHide(){
  // Wenn Flyout eingeklappt wird: Pfeil nach aussen drehen
  pw.imgPfeil.src = 'Images/Pfeil.png';
  pw.imgPfeil.alt = 'Tastatur anzeigen';
  pw.Eingabe.focus();
}

function Flyout_onShow(){
  // Wenn Flyout ausgeklappt wird: Pfeil nach innen drehen
  pw.imgPfeil.src = 'Images/PfeilInv.png';
  pw.imgPfeil.alt = 'Tastatur ausblenden';
}

function onKeyUp_Event(Ereignis){
  // Tasten-Druck in Aktionen umsetzen
  
  // Return => Berechnen
  if(window.event.keyCode == 13) {
    calcFields();
    
  // Escape = > Alles zurücksetzen
  } else if (window.event.keyCode == 27) {
    resetFields();
  }
}

function calcFields(){
  // Funktion zu Berechnung der Ausgabe

  // Eingabe leer => Ausgabe auch leeren 
  if (pw.Eingabe.value == '') {
    pw.Ausgabe.value = '';
    
  // Eingabe nicht leer => berechnen und anzeigen
  } else {
    var str = pw.Eingabe.value;
  	//Eingabe von deutsch auf englisch umwandeln
  	if (System.Gadget.Settings.read("Zahlenformat") == "deutsch"){
      str = strReplace(str, ',', '.');
      str = strReplace(str, ';', ',');
    }
    try {
      pw.Ausgabe.value = eval('with(Math){' + str + '}');
      //Genauigkeit (auf 15 Stellen) verringern (sonst wird z.B. sin(PI) nicht genau 0)
      pw.Ausgabe.value = Math.round(pw.Ausgabe.value * Math.pow(10, 15))/Math.pow(10, 15);
      //Ggf. Ausgabe von englisch auf deutsch umwandeln
      if (System.Gadget.Settings.read("Zahlenformat") == "deutsch"){
        pw.Ausgabe.value = strReplace(pw.Ausgabe.value, '.', ',');
      }
    }catch(e){
      pw.Ausgabe.value = 'Fehler';
    }
  }
}

function resetFields(){
  // Funktion um Eingabe und Ausgabe zu leeren
  pw.Eingabe.value = '';
  pw.Ausgabe.value = ''; 
  pw.Eingabe.focus();
}

function showFlyout(){
  // Funktion klappt das Flyout entsprechend des aktuellen Status ein oder aus
  System.Gadget.Flyout.file = "Flyout.htm";
  System.Gadget.Flyout.show = !System.Gadget.Flyout.show;
}

function onClickBtn(Btn){
  // Funktion um Klick auf übergebenen Flyout-Button in Aktionen umzusetzen.
  switch (Btn){
    case 'Gleich': 
      calcFields();
      break;
    case 'Back':
      pw.Eingabe.value = pw.Eingabe.value.substring(0, pw.Eingabe.value.length - 1);
      break;
    default:
      pw.Eingabe.value += Btn;
      break;
  }
}

function onDblClickBtn(Btn){
  // Bei Doppel-Klick das Klick-Ereignis erneut auslösen 
  // (ermöglicht schnelleres Tippen von Zahlen mittels der Buttons)
  onClickBtn(Btn);
}

function strReplace(string, suchen, ersetzen) {
  // Funktion zum Ersetzen von beliebigen Vorkommen eines Strings innerhalb eines Strings
    ausgabe = string;
    while (ausgabe.indexOf(suchen) > -1) {
        pos = ausgabe.indexOf(suchen);
        ausgabe = (ausgabe.substring(0, pos) + ersetzen +
        ausgabe.substring((pos + suchen.length), ausgabe.length));
    }
    return ausgabe;
}

function onMouseOverBtn(Btn){
  // Funktion um übergebenen Flyout-Button auf glühendes Bild zu setzen.
  System.Gadget.Flyout.document.getElementById('Btn' + Btn).src = 'Images/Btn' + Btn + 'Glow.png';
}

function onMouseOutBtn(Btn){
  // Funktion um übergebenen Flyout-Button auf normales Bild zu setzen.
  System.Gadget.Flyout.document.getElementById('Btn' + Btn).src = 'Images/Btn' + Btn + '.png';
}

function Pfeil_MouseOver(){
  // Pfeil-Button glühen lassen
  if (System.Gadget.Flyout.show) imgPfeil.src = 'Images/PfeilInvGlow.png'; else imgPfeil.src = 'Images/PfeilGlow.png';
}

function Pfeil_MouseOut(){
  // Glühen des Pfeil-Buttons abschalten
  if (System.Gadget.Flyout.show) imgPfeil.src = 'Images/PfeilInv.png'; else imgPfeil.src = 'Images/Pfeil.png';
}

function Clear_MouseOver(){
  // Clear-Button glühen lassen
  imgClear.src = 'Images/ClearGlow.png';
}

function Clear_MouseOut(){
  // Glühen des Clear-Buttons abschalten
  imgClear.src = 'Images/Clear.png';
}
